#include <avr/io.h>
#include <compat/ina90.h>		// ł_NOP, _CLI, _SEI`܂B
#include <avr/interrupt.h>
//#include "avr205_frequency_measure_interrupt.h"
#include "freq_meter.h"

#if defined(__AVR_ATmega48__) | defined(__AVR_ATmega88__) | defined(__AVR_ATmega168__)
unsigned int 	x48_cnt_to_four_ints;
#endif

unsigned int	freq_cntr_freq_divd_by_10;

/*! \brief AVRӋ@\̏֐
 *
 * ̊֐͐ڑꂽӋ@\ɖ޲Ă𑗂AԂԕ҂܂B
 *
 *  \note Ӌ@\͐ɏĂȂ΂Ȃ܂B
 *
 */
void freq_cntr_init(void) {
  // T0݂ɂė鐳(㏸)[𐔂16ޯFREQ_CNTR
#if defined(__AVR_ATtiny261__) | defined(__AVR_ATtiny461__) | defined(__AVR_ATtiny861__)
  FREQ_CNTR_CTRLA = (1<<TC_COUNTMODE);		// /016ޯē`Ԃɐݒ
#endif
#if defined(__AVR_ATmega48__) | defined(__AVR_ATmega88__) | defined(__AVR_ATmega168__)
  FREQ_CNTR_CTRLA = 0;						// $FFFFłOVF̕W16ޯē`
#endif
  // ̺ނɂ͊荞݂Ȃ΂Ȃ܂B
}

//! GATE_CNTR0.1b̎Jp̎ԊƂĎgp܂B

/*! \brief 荞݂gp鎞ɁÅ֐͑菈n߂̂ɌĂ΂܂B\n
 * \T0ݕω̏Ԃ16ޯĎgvn߂܂B\n
 *
 *  - ̊֐͑Z҂(߰ݸ)Ɏgp܂B\n
 *
 */
void freq_cntr_start_measurement(void){
  //! ŏxPB6̏㏸[m邽߁Aݕω荞݂܂B
#if defined(__AVR_ATtiny261__) | defined(__AVR_ATtiny461__) | defined(__AVR_ATtiny861__)
  PIN_CHG_MASK = (1<<PIN_CHG_INT);
  GEN_INT_MASK = (1<<PIN_CHG_INT_ENAB);
#endif
#if defined(__AVR_ATmega48__) | defined(__AVR_ATmega88__) | defined(__AVR_ATmega168__)
  PIN_CHG_MASK = (1<<PIN_CHG_INT);// for megax8;
  GEN_INT_MASK = (1<<PIN_CHG_INT_ENAB);
#endif
}

/*! \brief ۸т10ŊꂽgԂ܂B\n
 * \freq_cntr_freq_divd_by_100łȂɁAꂪ̊֐ɂĎ۸тɑ܂B
 */
unsigned int	freq_cntr_get_result(void)
{
  return freq_cntr_freq_divd_by_10;
}

/*! \brief ̎gv邽߂Ɍʂ\n
 */
void	freq_cntr_clear_result(void)
{
  freq_cntr_freq_divd_by_10 = 0;
}

ISR(PIN_CHG_vect) {
  if ((PIN & (1<<PIN_NO)) !=0)
  {
	PIN_CHG_MASK	= (0<<PIN_CHG_INT);
	GEN_INT_MASK &= ~(1<<PIN_CHG_INT_ENAB);
	GATE_CNTR_INT_FLAG_REG	 |= (1<<GATE_CNTR_OVF_FLAG);	// GATE_CNTR׸މ

	// tiny x61:PB6܂mega x8:PD5ɂėMv邽߂FREQ_CNTR
	FREQ_CNTR_COUNT_HIGH  = 0x00;							// v8ޯĉ
	FREQ_CNTR_COUNT_LOW  = 0x00;							// v퉺8ޯĉ
	FREQ_CNTR_CTRLB = (1<<CLOCK_SEL_2)|(1<<CLOCK_SEL_1);	// FREQ_CNTR͸ۯI

	// \ߐݒ肳ȉ̌v0.1b/512s=195.3ɂČ߂܂B
	// TCNT1=255-195;	// 0.1b̒x𐶐邽߂GATE_CNTR㏸v͂̒lŐݒ肳܂B
#if defined(__AVR_ATtiny261__) | defined(__AVR_ATtiny461__) | defined(__AVR_ATtiny861__)
	GATE_CNTR_COUNT = GATE_CNTR_PRELOAD;
	GATE_CNTR_COUNT_HI = 3;
	GATE_CNTR_INT_MASK_REG = (1<<GATE_CNTR_OVF_INT_ENAB);
#endif
#if defined(__AVR_ATmega48__) | defined(__AVR_ATmega88__) | defined(__AVR_ATmega168__)
	GATE_CNTR_COUNT = 0;
#endif

	GATE_CNTR_INT_MASK_REG = (1<<GATE_CNTR_OVF_INT_ENAB);
#if defined(__AVR_ATtiny261__) | defined(__AVR_ATtiny461__) | defined(__AVR_ATtiny861__)
	GATE_CNTR_CTRLB = (1<<CLOCK_SEL_13)|(1<<CLOCK_SEL_12)|(1<<CLOCK_SEL_10);//start GATE_CNTR
#endif
#if defined(__AVR_ATmega48__) | defined(__AVR_ATmega88__) | defined(__AVR_ATmega168__)
	GATE_CNTR_CTRLB = (1<<CLOCK_SEL_02)|(1<<CLOCK_SEL_00);	// 1/1024Amega x8ł͍ő啪\
	x48_cnt_to_four_ints = 0;								// O4̊荞݂𐔂x48v
#endif
  }
  // ~[ݕω荞݌mÂɂ𖳎
}

////////////////////////////////

ISR(GATE_CNTR_OVF_vect) {

#if defined(__AVR_ATmega48__) | defined(__AVR_ATmega88__) | defined(__AVR_ATmega168__)
  x48_cnt_to_four_ints++;
  if(x48_cnt_to_four_ints == 3)GATE_CNTR_COUNT = 0xff-13;
  if(x48_cnt_to_four_ints >= 4)
  {
	FREQ_CNTR_CTRLB = 0;					// FREQ_CNTR~
	GATE_CNTR_CTRLB = 0;

//	ovf_test_and_return_result();			// ʂfreq_cntr_freq_divd_by_10ɔzu
	// 16ޯĈɊւTIFRA͈͂$FFFFԂB
	if ((FREQ_CNTR_INT_FLAG_REG & (1<<FREQ_CNTR_OVF_FLAG)) !=0) {
	  // 16ޯĈɊւGATE_CNTR_OVF_FLAG
	  freq_cntr_freq_divd_by_10 = 0xFFFF;	// OVFԂԂ܂B
	}
	else {
	  freq_cntr_freq_divd_by_10 = FREQ_CNTR_COUNT_LOW+(FREQ_CNTR_COUNT_HIGH<<8);
	}
  }
#endif

#if defined(__AVR_ATtiny261__) | defined(__AVR_ATtiny461__) | defined(__AVR_ATtiny861__)
  {
	FREQ_CNTR_CTRLB = 0;
	GATE_CNTR_CTRLB = 0;

//	ovf_test_and_return_result();			// ʂfreq_cntr_freq_divd_by_10ɔzu
	// 16ޯĈɊւTIFRA͈͂$FFFFԂB
	if ((FREQ_CNTR_INT_FLAG_REG & (1<<FREQ_CNTR_OVF_FLAG)) !=0) {
	  // 16ޯĈɊւGATE_CNTR_OVF_FLAG
	  freq_cntr_freq_divd_by_10 = 0xFFFF;	// OVFԂԂ܂B
	}
	else {
	  freq_cntr_freq_divd_by_10 = FREQ_CNTR_COUNT_LOW+(FREQ_CNTR_COUNT_HIGH<<8);
	}
  }
#endif
}
